



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>501. Find Mode in Binary Search Tree</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">501. Find Mode in Binary Search Tree</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-25 05:19:50 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<p>Given a binary search tree (BST) with duplicates, find all the&nbsp;<a href="https://en.wikipedia.org/wiki/Mode_(statistics)" rel="external nofollow noreferrer">mode(s)</a>&nbsp;(the most frequently occurred element) in the given BST.</p>
<p>Assume a BST is defined as follows:</p>
<ul><li>The left subtree of a node contains only nodes with keys&nbsp;less than or equal to&nbsp;the node's key.</li>
<li>The right subtree of a node contains only nodes with keys&nbsp;greater than or equal to&nbsp;the node's key.</li>
<li>Both the left and right subtrees must also be binary search trees.</li></ul>
<p>For example:<br />Given BST&nbsp;<code>[1,null,2,2]</code>,</p>
<pre class="prettyprint linenums">   1<br />
    \<br />
     2<br />
    /<br />
   2
</pre>
<p>return&nbsp;<code>[2]</code>.</p>
<p>Note:&nbsp;If a tree has more than one mode, you can return them in any order.</p>
<p>Follow up:&nbsp;Could you do that without using any extra space? (Assume that the implicit stack space incurred due to recursion does not count).</p>
<p>思路：</p>
<p>对于本题中的二叉搜索树，节点的排列是有顺序的，左节点&lt;=当前节点&lt;=右节点。也就是说，假设这样一种情况：存在大于等于3个的连续相同的节点，且当前节点存在左右子树，那么相同的三个节点一定是：当前节点、左子树中最大的节点和右子树中最小的节点。</p>
<p>这里我们容易想到的是中序遍历（对于整个树，先遍历左节点，再遍历中间节点，最后遍历右节点），使用中序遍历遍历二叉搜索树，可以获得一个从小到大的排好序的升序序列。</p>
<p>所以分析到这里，题目就转化成：给定一个升序序列，寻找重复次数最多的数字 ， 所以</p>
<div>
<pre class="prettyprint linenums">/**<br />
 * Definition for a binary tree node.<br />
 * struct TreeNode {<br />
 *     int val;<br />
 *     TreeNode *left;<br />
 *     TreeNode *right;<br />
 *     TreeNode(int x) : val(x), left(NULL), right(NULL) {}<br />
 * };<br />
 */<br />
class Solution {<br />
public:<br />
    vector&lt;int&gt; findMode(TreeNode* root) {<br />
        tmp_cnt = ;<br />
        max_cnt = ;<br />
        cur_value = ;<br />
        inorder(root);<br />
        return result;<br />
    }<br />
private:<br />
    int tmp_cnt;<br />
    int max_cnt;<br />
    int cur_value;<br />
    vector&lt;int&gt; result;<br />
    void inorder(TreeNode* root){<br />
        if (root == NULL){<br />
            return;<br />
        }<br />
        // 遍历左子树<br />
        inorder(root-&gt;left);<br />
        tmp_cnt++;<br />
        if (cur_value != root-&gt; val){<br />
            cur_value = root-&gt; val;<br />
            tmp_cnt = ;<br />
        }<br />
        if (tmp_cnt &gt; max_cnt){<br />
            max_cnt = tmp_cnt;<br />
            result.clear();<br />
            result.push_back(root-&gt;val);<br />
        }else if (tmp_cnt == max_cnt){<br />
            result.push_back(root-&gt;val);<br />
        }<br />
        // 遍历右子树<br />
        inorder(root-&gt;right);<br />
    }<br />
};</pre>
</div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/390w4oqd.html">gitignore 规范</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvej2x9.html">变量声明和定义及extern 转载</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8k6edrq.html">php访问url的四种方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96wve3q.html">【转】编译quickfast解析库（沪深level2行情转码库）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1g6k19.html">scala简单的文件操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/96oj1v49.html">js将数组元素随机排序的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mzn7eq.html">iOS探索：对NSArray中自定义的对象进行排序</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e12myz9.html">win8&period;1中如何获得管理员权限步骤</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm47d69.html">Android Activity 分类</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmnv579.html">新建一个类并绑定一个activity</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rg4ynm8.html">VS2008中Run-Time Check Failure &num;2 - Stack around the variable &apos;xxx&apos; was corrupted 错误解决方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gj1zl09.html">mysql5&period;7&period;25安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/q255rx3q.html">SVN的工作原理及流程手册</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7ogg4x8.html">SuperWebSocket与Cocos2dx通信时执行不了命令的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2j0jj9.html">Python随笔--序列</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllx5nkq.html">Mysql存储过程入门介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdw1nyj9.html">Java多线程系列&mdash;&mdash;线程池原理之 ThreadPoolExecutor</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4j1gxnq.html">tensorflow随机梯度下降算法使用滑动平均模型</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1r62lz8.html">JOBDU 题目1131：合唱队形</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4pk1y3q.html">JDK-8不是有效的Win32应用程序</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8eygk7e9.html">java8 Stream常用方法和特性浅析</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpegpj9.html">javascript权威指南笔记&lbrack;1-5&rsqb;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxk3m608.html">js node&period;js 编写命令工具demo</a>
			</li>
						<li><a href="https://www.batexi.com/a/qljr6e69.html">在vue项目中添加全局提示框</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnjxp1x8.html">MS SQL 锁与事务</a>
			</li>
						<li><a href="https://www.batexi.com/a/qljrgve9.html">Cookie浅析</a>
			</li>
						<li><a href="https://www.batexi.com/a/8me5gyoq.html">校园生活app结对开发第二天</a>
			</li>
						<li><a href="https://www.batexi.com/a/950e67e8.html">C&num;属性标记Order执行顺序备忘录</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpe3zr9.html">Java集合类源码解析：Vector</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnjo1zj8.html">&period;net开源工作流引擎ccflow Pop返回值设置</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
